untyped

global function Init_NukeRocket
global function SetupRocketMarvin
global function TryFireNuke

void function Init_NukeRocket()
{
    
}

void function SetupRocketMarvin( DropShiptruct dropship )
{
    entity mover = dropship.dropship.mover
    
    vector origin = mover.GetForwardVector() * 350 + mover.GetOrigin()
    entity marvin = CreateMarvin( mover.GetTeam(), origin, mover.GetAngles() )
	DispatchSpawn( marvin )
	marvin.SetInvulnerable()
    marvin.SetParent( mover )
	marvin.SetNoTarget( true )
	marvin.ContextAction_SetBusy()
	HideName( marvin )
	marvin.SetTitle( "dropship" )

    TakeAllWeapons( marvin )
    marvin.GiveWeapon( "mp_titanweapon_rocketeer_rocketstream" )
	marvin.SetActiveWeaponByName( "mp_titanweapon_rocketeer_rocketstream" )

	marvin.MakeInvisible()

    dropship.dropship.pilot = marvin
}

void function TryFireNuke( DropShiptruct dropship )
{
	// really jank
	entity mover = dropship.dropship.mover
	entity owner = dropship.dropship.pilot
	
	if ( !IsValid( owner ) )
		SetupRocketMarvin( dropship )
	
	owner = dropship.dropship.pilot
	entity weapon = owner.GetActiveWeapon()
	owner.SetAngles( mover.GetAngles() )

    if ( dropship.time_fired > Time() )
    {
		entity player = dropship.dropship.model.GetOwner()
		EmitSoundOnEntityOnlyToPlayer( player, player, "UI_Networks_Invitation_Canceled" )
		return
	}
	
	// stop moving >:(
	// owner.SetOrigin( ( mover.GetForwardVector() * 350 ) + mover.GetOrigin() )
	
    dropship.time_fired = Time() + 30
    
    weapon.EmitWeaponNpcSound( LOUD_WEAPON_AI_SOUND_RADIUS_MP, 0.2 )

	bool shouldPredict = weapon.ShouldPredictProjectiles()

    WeaponPrimaryAttackParams attackParams
    attackParams.pos = mover.GetOrigin() + mover.GetForwardVector() * 350 * 1000
    attackParams.dir = mover.GetForwardVector() * 1000

	// Get missile firing information
	// vector offset
	// int altFireIndex = weapon.GetCurrentAltFireIndex()
	// float horizontalMultiplier
	// if ( altFireIndex == 1 )
	// 	horizontalMultiplier = RandomFloatRange( 0.25, 0.45 )
	// else
	// 	horizontalMultiplier = RandomFloatRange( -0.45, -0.25 )

	// if ( owner.IsPlayer() )
	// 	offset = AnglesToRight( owner.CameraAngles() ) * horizontalMultiplier
	// #if SERVER
	// else
	// 	offset = owner.GetPlayerOrNPCViewRight() * horizontalMultiplier
	// #endif

	vector attackDir = attackParams.dir // + offset + <0,0,RandomFloatRange(-0.25,0.55)>
	vector attackPos = attackParams.pos // + offset*32
	attackDir = Normalize( attackDir )
	entity missile = weapon.FireWeaponMissile( attackPos, attackDir, 1, (damageTypes.projectileImpact | DF_DOOM_FATALITY), damageTypes.explosive, false, shouldPredict )
	EmitSoundAtPosition( owner.GetTeam(), mover.GetOrigin(), "Weapon_FlightCore_Incoming_Projectile" )

	if ( missile )
	{
		TraceResults result = TraceLine( attackParams.pos, attackParams.pos + attackParams.dir*50000, [ owner ], TRACE_MASK_SHOT, TRACE_COLLISION_GROUP_BLOCK_WEAPONS )
		missile.kv.lifetime = 5
		attackParams.pos = result.endPos
		// missile.InitMissileForRandomDriftFromWeaponSettings( attackPos, attackDir )
		missile.SetSpeed( 100 )
		missile.SetOwner( owner )
		EmitSoundAtPosition( owner.GetTeam(), attackParams.pos, "Weapon_FlightCore_Incoming_Projectile" )

		thread MissileThink( missile, owner, attackParams )
    }
}

void function MissileThink( entity missile, entity owner, WeaponPrimaryAttackParams attackParams )
{
	missile.EndSignal( "OnDestroy" )

	attackParams.pos = missile.GetOrigin()

	OnThreadEnd(
		function() : ( missile, owner, attackParams )
		{
			if ( IsValid( missile ) )
				missile.Destroy()
			
			if ( !IsValid( owner ) )
				return
			
			entity weapon = GetPrimaryWeapons( owner )[0]

			entity grenade = weapon.FireWeaponGrenade( attackParams.pos, attackParams.dir, <0,0,0>, 0, damageTypes.projectileImpact, damageTypes.explosive, false, true, true )
			thread DoNuclearExplosion( grenade, eDamageSourceId.mp_titancore_nuke_missile )
		}
	)

	float life = float( missile.kv.lifetime ) + Time()

	while( life > Time() )
	{
		attackParams.pos = missile.GetOrigin()
		WaitFrame()
	}
}